<template>
    <b-container @change="changeInput">
        <b-row  class="mb-2" v-for="(contact, index) in this.$v.value.$each.$iter" :key="contact.id">
            <b-col class="mb-2">
                <label for="contact-type"> Tipo di contatto </label>
                <b-form-select id="contact-type"
                               v-model="contact.contactTypeId.$model"
                               :state="contact.contactTypeId.$model === null ? null : !contact.contactTypeId.$invalid"
                >
                    <b-form-select-option :key="type.id"
                                          v-for="type in $props.contactTypes"
                                          :value="type.id">
                        {{ type.name }}
                    </b-form-select-option>
                </b-form-select>
            </b-col>
            <b-col sm="12" md="4" lg="5" class="mb-2" v-if="contact.contactTypeId.$model === 1">
                <label for="email-form"> Indirizzo Email </label>
                <b-form-input id="email-form"
                              v-model="contact.name.$model"
                              autocomplete="off"
                              type="email"
                              :state="contact.name.$model === null ? null : !contact.name.$invalid"
                              placeholder="Indirizzo email"
                              class="shop-input"
                />
            </b-col>
            <b-col sm="12" md="4" lg="5" class="mb-2" v-else-if="contact.contactTypeId.$model === 2">
                <label for="whatsapp-form">Contatto WhatsApp</label>
                <b-input-group prepend="+39">
                    <b-form-input id="whatsapp-form"
                                  v-model="contact.name.$model"
                                  autocomplete="off"
                                  type="text"
                                  :state="contact.name.$model === null ? null : !contact.name.$invalid"
                                  placeholder="Whatsapp"
                                  class="shop-input"
                    />
                </b-input-group>

            </b-col>
            <b-col sm="12" md="4" lg="5" v-else-if="contact.contactTypeId.$model === 3">
                <label for="telephone-form">Numero di telefono</label>
                <b-input-group prepend="+39">
                    <b-form-input id="telephone-form"
                                  v-model="contact.name.$model"
                                  autocomplete="off"
                                  type="text"
                                  :state="contact.name.$model === null ? null : !contact.name.$invalid"
                                  placeholder="Telefono"
                                  class="shop-input"
                    />
                </b-input-group>
            </b-col>
            <b-col sm="12" md="4" lg="2" class="d-flex align-items-end mb-2 align-middle">
                <b-button variant="danger" style="width: 100%" :disabled="isTheOnlyElement" @click="remove(index)">Rimuovi</b-button>
            </b-col>
        </b-row>
        <b-button variant="primary" class="mt-2" @click="add">Aggiungi Contatto</b-button>
    </b-container>
</template>

<script>
    import { required } from 'vuelidate/src/validators';

    export default {
        name: "ContactForm",
        props: {
            contactTypes: {
                type: Array
            },
            value: {
                type: Array
            },
        },
        data() {
            return {
                numberElements: 1
            }
        },
        validations: {
            value: {
                required,
                $each: {
                    contactTypeId: {
                        required
                    },
                    name: {
                        required
                    }
                }
            }
        },
        mounted() {
            this.$props.value.push({id: 0, name: null, contactTypeId: null});
        },
        computed: {
            isTheOnlyElement() {
                return this.$props.value.length === 1
            }
        },
        methods: {
            add() {
                this.numberElements++;
                this.$props.value.push({id: this.numberElements, name: null, contactTypeId: null});
            },
            remove(index) {
                if (this.$props.value.length > 1) {
                    this.$props.value.splice(index, 1);
                }
            },
            changeInput() {
                this.$emit('changeInput', this.$v.$invalid);
            }
        }
    }
</script>

<style scoped>

</style>
